/**
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

import { defineStore } from 'pinia'
import { ref } from 'vue'
import axios from '@nextcloud/axios'
import { generateUrl } from '@nextcloud/router'

export const useConfigStore = defineStore('config', () => {
  const config = ref(null)
  const appConfig = ref(null)

  async function getConfig() {
    if (config.value !== null) {
      return config.value
    }

    config.value = await axios.get(generateUrl('/apps/side_menu/js/config')).then((response) => response.data)

    return config.value
  }

  async function getAppConfig() {
    if (appConfig.value !== null) {
      return appConfig.value
    }

    appConfig.value = await axios.get(generateUrl('/apps/side_menu/admin/config')).then((response) => response.data)

    return appConfig.value
  }

  return {
    getConfig,
    getAppConfig,
  }
})
